"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const Transformer_1 = require("./Transformer");
class FlowTransformer extends Transformer_1.default {
    constructor(rootTransformer, tokens) {
        super();
        this.rootTransformer = rootTransformer;
        this.tokens = tokens;
    }
    process() {
        // We need to handle all classes specially in order to remove `implements`.
        if (this.tokens.matchesKeyword("class")) {
            this.rootTransformer.processClass();
            return true;
        }
        const processedTypeAnnotation = this.rootTransformer.processPossibleTypeAnnotation();
        if (processedTypeAnnotation) {
            return true;
        }
        if (this.tokens.currentToken().contextName === "type") {
            this.tokens.removeInitialToken();
            while (this.tokens.currentToken().contextName === "type") {
                this.tokens.removeToken();
            }
            return true;
        }
        if (this.tokens.currentToken().contextName === "typeParameter") {
            this.tokens.removeInitialToken();
            while (this.tokens.currentToken().contextName === "typeParameter") {
                this.tokens.removeToken();
            }
            return true;
        }
        return false;
    }
}
exports.default = FlowTransformer;
